// ============================================================================
// BDreaderGAMEBDoutputCave.cpp
// ----------------------------------------------------------------------------
// (c) 2022-2024 by HerzAusGold
//               Hubert Haberkorn
//               herz-aus-gold-42@gmx.de
//               http://www.arthurdent.de/
// ----------------------------------------------------------------------------
// The above copyright notice and this permission notice 
// shall be included in all copies or substantial portions 
// of the Software.
// ----------------------------------------------------------------------------
// read file dump from "BoulderDsh" (by Guido Mersmann) 
// and extract level data to -> ".gamebd" file
// generate "levelinfo.conf" with some extra info
// ============================================================================

#include "BDreaderGAMEBDmain.h"
#include "BDreaderGAMEBDutil.h"
#include "BDreaderGAMEBDoutputCave.h"

using namespace std;

//---------------------------------------------------------------------------
// output Cave
//---------------------------------------------------------------------------
void outputCave(cave_t &cave, int maxx, int maxy, int cavelen,
                std::string (*convertFunc)(int,int,int,bool&))
{
    int x = 0;
    int y = 0;
    printf ("== cave maxx: %d maxy: %d cavelen: %d\n", maxx, maxy, cavelen);
    for(int i=0; i < cavelen; i++) {
        byte_t levb = cave.cave[i];
        byte_t elem = levb;
        byte_t cnte = 1;
        bool   elemFound = false;
        if (levb == 0xFF) {
            i++;
            elem = cave.cave[i];
            if (elem == 0xFF) {
                if (i+1 != cavelen) {
                    printf("-E- error = ERR_CAVE_LEN\n");
                }
                break;
            }
            i++;
            cnte = cave.cave[i];
        }
        string sele = convertFunc(x, y, elem, elemFound);  // convert
        if (!elemFound) {
            sele = convertFunc(x, y, elem, elemFound);     // convert again // for debugging
        }
        for(int e=0; e < cnte; e++) {
            printf("%s", sele.c_str());
            x++;
            if (x >= maxx) {
                printf("\n");
                x = 0;
                y++;
            }
        }
    }
    printf("\n");
}
