// ============================================================================
// decodeCaveCommon.h
// ----------------------------------------------------------------------------
// (c) 2022-2024 by HerzAusGold
//               Hubert Haberkorn
//               herz-aus-gold-42@gmx.de
//               http://www.arthurdent.de/
// ----------------------------------------------------------------------------
// The above copyright notice and this permission notice 
// shall be included in all copies or substantial portions 
// of the Software.
// ----------------------------------------------------------------------------
// read "raw" file dump and extract the data with parameters.
// create .WLC file - WithLevelCommon
// ----------------------------------------------------------------------------

#ifndef DECODECAVECOMMON_H
#define DECODECAVECOMMON_H

#include "decodeCave.h"
#include <map>
#include <string>

const std::string c_feature_command0x0F = "command0x0F";

/* ******************************************************* */
/* Prototypes */
/* **************************************** */
class DecodeCaveCommon : public DecodeCave {
    public:
        UBYTE GetCommand(UBYTE cmd);
        UBYTE GetCommandLength(UBYTE cmd);
        void DoDecodeCave(unsigned char caveNo, UBYTE *aCaveData, int offpara, UBYTE *prog);

        void SetFeature(std::string key, int value);
        bool GetFeature(std::string key, int& value);

    private:
        std::map<std::string, int> featureMap;        
};

#endif
